-- ---------------------------------------------------------------------------
-- (2009) Benjamin Krill <ben@codiert.org>
--
-- "THE BEER-WARE LICENSE" (Revision 42):
-- ben@codiert.org wrote this file. As long as you retain this notice you can
-- do whatever you want with this stuff. If we meet some day, and you think
-- this stuff is worth it, you can buy me a beer in return Benjamin Krill
-- ---------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use IEEE.STD_Logic_unsigned.all;
use IEEE.numeric_std.all;

entity rrarbiter_tb is
end rrarbiter_tb;

architecture rtl of rrarbiter_tb is
	constant CLK_PERIOD : time := 36 ns;

	signal clk       : std_logic;
	signal rst       : std_logic;
	signal rst_n     : std_logic;

	signal req       : std_logic_vector(6 downto 0);
	signal grant     : std_logic_vector(6 downto 0);
	signal ack       : std_logic;
begin
	rst   <= transport '1', '0' after ( 4 * CLK_PERIOD);
	rst_n <= not rst;

	clock:	process
	begin
		clk <= '1', '0' after CLK_PERIOD/2;
		wait for Clk_PERIOD;
	end process;

	beh: process
	begin
		req <= "0000000";
		wait for 10*CLK_PERIOD;
		req <= "0000011";
		wait for 5*CLK_PERIOD;
		req <= "0000000";
		wait for 5*CLK_PERIOD;
		req <= "0001111";
		wait for 5*CLK_PERIOD;
		req <= "0001110";
		wait for 20*CLK_PERIOD;
		req <= "0000000";
		wait for 20*CLK_PERIOD;
		wait;
	end process beh;

	beh0: process
	begin
		ack <= '0';
		wait for 10*CLK_PERIOD;
		wait for 6*CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for 8*CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for 5*CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for 2*CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		ack <= '1';
		wait for CLK_PERIOD;
		ack <= '0';
		wait for CLK_PERIOD;
		wait for 20*CLK_PERIOD;
		wait;
	end process beh0;

	DUT: entity work.rrarbiter_reg
	port map (
		clk   => clk,
		rst_n => rst_n,

		ack   => ack,
		req   => req,
		grant => grant
	);

end rtl;

configuration rrarbiter_tb_rtl_cfg of rrarbiter_tb is
  for rtl
  end for;
end rrarbiter_tb_rtl_cfg;
